# SPDX-License-Identifier: (GPL-2.0-only OR BSD-2-Clause)
%YAML 1.2
---
$id: http://devicetree.org/schemas/nvmem/mediatek,efuse.yaml#
$schema: http://devicetree.org/meta-schemas/core.yaml#

title: MediaTek efuse

description: |
  MediaTek's efuse is used for storing calibration data, it can be accessed
  on ARM devices usiong I/O mapped memory.

maintainers:
  - Andrew-CT Chen <andrew-ct.chen@mediatek.com>
  - Lala Lin <lala.lin@mediatek.com>

allOf:
  - $ref: nvmem.yaml#
  - $ref: nvmem-deprecated-cells.yaml#

properties:
  $nodename:
    pattern: "^efuse@[0-9a-f]+$"

  compatible:
    oneOf:
      - items:
          - enum:
              - mediatek,mt7622-efuse
              - mediatek,mt7623-efuse
              - mediatek,mt7986-efuse
              - mediatek,mt8173-efuse
              - mediatek,mt8183-efuse
              - mediatek,mt8186-efuse
              - mediatek,mt8188-efuse
              - mediatek,mt8192-efuse
              - mediatek,mt8195-efuse
              - mediatek,mt8516-efuse
          - const: mediatek,efuse
      - const: mediatek,mt8173-efuse
        deprecated: true

  reg:
    maxItems: 1

required:
  - compatible
  - reg

unevaluatedProperties: false

examples:
  - |
    efuse@11c10000 {
        compatible = "mediatek,mt8195-efuse", "mediatek,efuse";
        reg = <0x11c10000 0x1000>;
        #address-cells = <1>;
        #size-cells = <1>;

        u3_tx_imp_p0: usb3-tx-imp@184,1 {
            reg = <0x184 0x1>;
            bits = <0 5>;
        };
        u3_rx_imp_p0: usb3-rx-imp@184,2 {
            reg = <0x184 0x2>;
            bits = <5 5>;
        };
        u3_intr_p0: usb3-intr@185 {
            reg = <0x185 0x1>;
            bits = <2 6>;
        };
        comb_tx_imp_p1: usb3-tx-imp@186,1 {
            reg = <0x186 0x1>;
            bits = <0 5>;
        };
        comb_rx_imp_p1: usb3-rx-imp@186,2 {
            reg = <0x186 0x2>;
            bits = <5 5>;
        };
        comb_intr_p1: usb3-intr@187 {
            reg = <0x187 0x1>;
            bits = <2 6>;
        };
        u2_intr_p0: usb2-intr-p0@188,1 {
            reg = <0x188 0x1>;
            bits = <0 5>;
        };
        u2_intr_p1: usb2-intr-p1@188,2 {
            reg = <0x188 0x2>;
            bits = <5 5>;
        };
    };
